#include <utility>

template<class T> inline void plus_elem(T &A1, T&A2) {
  T a1=A1,a2=A2 ;
  if(a1>a2) {
    A1=a2 ;
    A2=a1 ;
  }
} 

template<class T> inline void minus_elem(T &A1, T&A2) {
  T a1=A1,a2=A2 ;
  if(a1<a2) {
    A1=a2 ;
    A2=a1 ;
  }
} 


template<class T, int N, int I> struct meta_split_P {
  static inline void split(T *A) {
    plus_elem(A[I],A[I+N/2]) ;
    meta_split_P<T,N,I-1>::split(A) ;
  }
} ;

template<class T, int N> struct meta_split_P<T,N,0> {
  static inline void split(T *A) {
    plus_elem(A[0],A[0+N/2]) ;
  }
} ;

template<class T, int N, int I> struct meta_split_M {
  static inline void split(T *A) {
    minus_elem(A[I],A[I+N/2]) ;
    meta_split_M<T,N,I-1>::split(A) ;
  }
} ;

template<class T, int N> struct meta_split_M<T,N,0> {
  static inline void split(T *A) {
    minus_elem(A[0],A[0+N/2]) ;
  }
} ;


template<class T, int N> struct meta_merge_P {
  static inline void merge(T *A) {
    meta_split_P<T,N,N/2-1>::split(A) ;
    meta_merge_P<T,N/2>::merge(A) ;
    meta_merge_P<T,N/2>::merge(A+N/2) ;
  }
} ;

template<class T>  struct meta_merge_P<T, 2> {
  static inline void merge(T *A) {
    meta_split_P<T,2,0>::split(A) ;
  }
} ;


template<class T, int N> struct meta_merge_M {
  static inline void merge(T *A) {
    meta_split_M<T,N,N/2-1>::split(A) ;
    meta_merge_M<T,N/2>::merge(A) ;
    meta_merge_M<T,N/2>::merge(A+N/2) ;
  }
} ;

template<class T>  struct meta_merge_M<T, 2> {
  static inline void merge(T *A) {
    meta_split_M<T,2,0>::split(A) ;
  }
} ;

template<class T, int N> struct bitonic_sort_M ;

template<class T, int N> struct bitonic_sort_P {
  static inline void sort(T *A) {
    bitonic_sort_P<T,N/2>::sort(A) ;
    bitonic_sort_M<T,N/2>::sort(A+N/2) ;
    meta_merge_P<T,N>::merge(A) ;
  }
} ;

template<class T> struct bitonic_sort_P<T,2> {
  static inline void sort(T *A) {
    meta_merge_P<T,2>::merge(A) ;
  }
} ;

template<class T, int N> struct bitonic_sort_M {
  static inline void sort(T *A) {
    bitonic_sort_P<T,N/2>::sort(A) ;
    bitonic_sort_M<T,N/2>::sort(A+N/2) ;
    meta_merge_M<T,N>::merge(A) ;
  }
} ;

template<class T> struct bitonic_sort_M<T,2> {
  static inline void sort(T *A) {
    meta_merge_M<T,2>::merge(A) ;
  }
} ;

template<class T, int N> struct bitonic_sort {
  static inline void sort(T *A) {
    bitonic_sort_P<T,N>::sort(A) ;
  }
} ;
